-------------------------------------------------------------
-------------------------------------------------------------
--Name 			: Matt Smith, Ronald Koss, and Chan Min
--Instructor	: Dr. Coulston
--Course		: CENBD 497A
--Assignment	: 20 Bits 2to1 Multiplexer
--Date			: Dec 6th, 2000	  
--Note 			: sel-line = 1 => output = B
--				: sel-line = 0 => output = A
-------------------------------------------------------------
-------------------------------------------------------------

Library IEEE;
Use IEEE.std_logic_1164.all;

entity mux20 is
	PORT ( 	A, B  	:IN  STD_LOGIC_VECTOR(19 DOWNTO 0);
			sel_line:IN  STD_LOGIC				  ;
			output  : OUT STD_LOGIC_VECTOR(19 DOWNTO 0) 
	);
end mux20;

architecture heart of mux20 is
	component mux2to1 
		port ( 	a0, b0: in  std_logic;
				sel	  : in  std_logic;
				Oput  : out std_logic  );	
	end component;	
begin
	box0  : mux2to1 port map(A(0 ), B(0 ), sel_line, output(0 ));
	box1  : mux2to1 port map(A(1 ), B(1 ), sel_line, output(1 ));
	box2  : mux2to1 port map(A(2 ), B(2 ), sel_line, output(2 ));
	box3  : mux2to1 port map(A(3 ), B(3 ), sel_line, output(3 ));
	box4  : mux2to1 port map(A(4 ), B(4 ), sel_line, output(4 ));
	box5  : mux2to1 port map(A(5 ), B(5 ), sel_line, output(5 ));
	box6  : mux2to1 port map(A(6 ), B(6 ), sel_line, output(6 ));
	box7  : mux2to1 port map(A(7 ), B(7 ), sel_line, output(7 ));
	box8  : mux2to1 port map(A(8 ), B(8 ), sel_line, output(8 ));
	box9  : mux2to1 port map(A(9 ), B(9 ), sel_line, output(9 ));
	box10 : mux2to1 port map(A(10), B(10), sel_line, output(10));
	box11 : mux2to1 port map(A(11), B(11), sel_line, output(11));
	box12 : mux2to1 port map(A(12), B(12), sel_line, output(12));
	box13 : mux2to1 port map(A(13), B(13), sel_line, output(13));
	box14 : mux2to1 port map(A(14), B(14), sel_line, output(14));
	box15 : mux2to1 port map(A(15), B(15), sel_line, output(15));
	box16 : mux2to1 port map(A(16), B(16), sel_line, output(16));
	box17 : mux2to1 port map(A(17), B(17), sel_line, output(17));
	box18 : mux2to1 port map(A(18), B(18), sel_line, output(18));
	box19 : mux2to1 port map(A(19), B(19), sel_line, output(19));
	
end heart;
