-------------------------------------------------------------
-------------------------------------------------------------
--Name 			: Math Smith, Ronald Koss, and Chan Min
--Instructor	: Dr. Coulston
--Course		: CENBD 497A
--Assignment	: Control For GetMinMax
--Date			: Dec 6th, 2000	  
-------------------------------------------------------------
-------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY DP IS
	PORT( 	data    : IN  STD_LOGIC_VECTOR(19 DOWNTO 0);
		min, max: OUT STD_LOGIC_VECTOR(19 DOWNTO 0);
		cw      : IN  STD_LOGIC_VECTOR(4  DOWNTO 1);	
		sw	: OUT STD_LOGIC;
		clk, reset: IN STD_LOGIC
	);
END DP;

ARCHITECTURE DP_MinMax OF DP IS 
COMPONENT reg20 
	PORT(	D : IN  STD_LOGIC_VECTOR(19  DOWNTO 0);
			Q : OUT STD_LOGIC_VECTOR(19  DOWNTO 0);
			Clr, Clk, control : IN STD_LOGIC
	);
END COMPONENT;

component ADDSUB 
	PORT(	a, b: IN  STD_LOGIC_VECTOR(19 DOWNTO 0);
			sum : OUT STD_LOGIC_VECTOR(19 DOWNTO 0);
			sel : IN  STD_LOGIC		      ;
			ovf, cout: OUT STD_LOGIC		);
END component;

SIGNAL stemp, sprev,sOut : STD_LOGIC_VECTOR(19  DOWNTO 0);
Signal One, dumb1, dumb2 : std_logic;

BEGIN
	
	One <= '1';
	
	temp : reg20 PORT MAP( data , stemp, reset, clk, cw(4)); 
	prev : reg20 PORT MAP( stemp, sprev, reset, clk, cw(3)); 
	min2 : reg20 PORT MAP( sprev, min  , reset, clk, cw(2)); 
	max2 : reg20 PORT MAP( sprev, max  , reset, clk, cw(1));
	as   : addsub port map( stemp, sprev, sOut, One, dumb1, dumb2); 
	sw <= sOut(19);

END DP_MinMax;
