-------------------------------------------------------------
-------------------------------------------------------------
--Name 			: Math Smith, Ronald Koss, and Chan Min
--Instructor	: Dr. Coulston
--Course		: CENBD 497A
--Assignment	: Datapath For GetDifference
--Date			: Dec 6th, 2000	  
-------------------------------------------------------------
-------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY GetDifference IS
	PORT(	min, max : IN  STD_LOGIC_VECTOR(19 DOWNTO 0);
		result   : OUT STD_LOGIC_VECTOR(19 DOWNTO 0);
		enable	 : IN  STD_LOGIC;
		clk,reset: IN STD_LOGIC
	);
END GetDifference;

ARCHITECTURE struct OF GetDifference IS

	COMPONENT reg20 
		PORT(	D : IN  STD_LOGIC_VECTOR(19  DOWNTO 0);
				Q : OUT STD_LOGIC_VECTOR(19  DOWNTO 0);
				Clr, Clk, control : IN STD_LOGIC
		);
	END COMPONENT;
	
	
	COMPONENT ADDSUB 
		PORT(	a, b: IN  STD_LOGIC_VECTOR(19 DOWNTO 0);
				sum : OUT STD_LOGIC_VECTOR(19 DOWNTO 0);
				sel : IN  STD_LOGIC		      ;
				ovf, cout: OUT STD_LOGIC		);
	END COMPONENT;
	
	SIGNAL answer : STD_LOGIC_VECTOR(19 DOWNTO 0);
	SIGNAL One, ovf, cout: STD_LOGIC;
BEGIN
	addsub2 : ADDSUB PORT MAP(max, min, answer, One, ovf, cout);
	result2 : reg20 PORT MAP(answer, result, reset, clk, enable);  --when req goes high, 
								   --result will be loaded		   
									   
	One <= '1';
END struct; 
