-------------------------------------------------------------
-------------------------------------------------------------
--Name 			: Matt Smith, Ronald Koss, and Chan Min
--Instructor	: Dr. Coulston
--Course		: CENBD 497A
--Assignment	: GetMinMax
--Date			: Dec 6th, 2000	  
-------------------------------------------------------------
-------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY GetMinMax IS
	PORT(	req   : IN  STD_LOGIC;
		done  : OUT STD_LOGIC;
		data  : IN  STD_LOGIC_VECTOR(19 DOWNTO 0);
		min, max: OUT STD_LOGIC_VECTOR(19 DOWNTO 0);
		clk, reset: IN STD_LOGIC
	);
END GetMinMax;

ARCHITECTURE struct OF GetMinMax IS

COMPONENT DP 
	PORT( 	data    : IN  STD_LOGIC_VECTOR(19 DOWNTO 0);
		min, max: OUT STD_LOGIC_VECTOR(19 DOWNTO 0);
		cw      : IN  STD_LOGIC_VECTOR(4  DOWNTO 1);	
		sw	: OUT STD_LOGIC;
		clk, reset: IN STD_LOGIC
	);
END COMPONENT;

COMPONENT contr_minmax 
	PORT(	req   : IN  STD_LOGIC;
		cw    : OUT STD_LOGIC_VECTOR(4 DOWNTO 0);
		sw    : IN  STD_LOGIC;
		clk, reset: IN STD_LOGIC
	);
END COMPONENT;

SIGNAL scw : STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL ssw : STD_LOGIC;

BEGIN
	cu: contr_minmax PORT MAP(req, scw, ssw, clk, reset); 
	dp2  : DP PORT MAP(data, min, max, scw(4 DOWNTO 1), ssw, clk, reset);
	
	done <= scw(0);			--I need this for GetDifference circuit.	
END struct;
		
