-------------------------------------------------------------
-------------------------------------------------------------
--Name 			: Math Smith, Ronald Koss, and Chan Min
--Instructor	: Dr. Coulston
--Course		: CENBD 497A
--Assignment	: 2to1 Multiplexer
--Date			: Dec 6th, 2000	  
--Note 			: sel-line = 1 => output = B
--				: sel-line = 0 => output = A
-------------------------------------------------------------
-------------------------------------------------------------

Library IEEE;
use IEEE.std_logic_1164.all;

entity mux2to1 is
	PORT ( 	a0, b0: IN STD_LOGIC;
			sel	  : IN STD_LOGIC;
			Oput  : OUT STD_LOGIC
	);	
end mux2to1;

architecture heart_2to1 of mux2to1 is
	signal s1, s2: std_logic;
begin
	s1 <= a0 and not sel;
	s2 <= b0 and sel	;
	
	Oput <= s1 or s2;
end heart_2to1;