-------------------------------------------------------------
-------------------------------------------------------------
--Name 			: Matt Smith, Ronald Koss, and Chan Min
--Instructor	: Dr. Coulston
--Course		: CENBD 497A
--Assignment	: 20 bit Register
--Date			: Dec 6th, 2000
--Note			:
-------------------------------------------------------------
-------------------------------------------------------------
Library IEEE;
Use IEEE.std_logic_1164.ALL;

ENTITY reg20 IS -- is actually a LATCH
	PORT(	D : IN  std_logic_vector (19 DOWNTO 0);
			Q : OUT std_logic_vector (19 DOWNTO 0);
			Clr, Clk, control :IN std_logic	    	);
END reg20;

ARCHITECTURE behav OF reg20 IS
	SIGNAL sq : std_logic_vector(19 DOWNTO 0);
BEGIN
	PROCESS (clk, clr, control) 
	BEGIN
		IF   (clr='1')THEN sq<= x"00000";
		ELSIF(control='1') 
			then sq <= d;                
		ELSIF(control='0')
			THEN sq <= sq; 
		END IF;             
 	END PROCESS;
	q <= sq;
END behav;
